"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.invokeServerlessLocalResource = void 0;
const executorPath_1 = require("amplify-nodejs-function-runtime-provider/lib/utils/executorPath");
const execa = require("execa");
const invokeServerlessLocalResource = (options, context) => __awaiter(void 0, void 0, void 0, function* () {
    var _a, _b;
    const childProcess = execa.node(executorPath_1.executorPath, [], {
        env: options.environment,
        extendEnv: true,
    });
    childProcess.send(options);
    // const childProcess = execa(
    //   'serverless',
    //   ['invoke', 'local', '-f', request.functionName, '--config', request.config, '--data', request.data],
    //   {
    //     input: request.event,
    //     env: { PATH: process.env.PATH, ...request.envVars }, // Java relies on PATH so we have to add that into the env
    //     extendEnv: false,
    //   }
    // );
    (_a = childProcess.stderr) === null || _a === void 0 ? void 0 : _a.pipe(process.stderr);
    (_b = childProcess.stdout) === null || _b === void 0 ? void 0 : _b.pipe(process.stdout);
    const { stdout, exitCode } = yield childProcess;
    if (exitCode !== 0) {
        throw new Error('LambdaFunctionInvokeError' + { message: `java failed, exit code was ${exitCode}` });
    }
    const lines = stdout.split('\n');
    const lastLine = lines[lines.length - 1];
    let result = lastLine;
    try {
        result = JSON.parse(lastLine);
    }
    catch (err) {
        context.print.warning('Could not parse function output as JSON. Using raw output.');
    }
    return result;
});
exports.invokeServerlessLocalResource = invokeServerlessLocalResource;
//# sourceMappingURL=invoke.js.map